#!/usr/bin/env python
from numpy import *
from numpy import fft
from numpy.random import rand
from matplotlib.pyplot import *

nmr = lambda x: exp(-x / 400.0) * (cos(2 * pi * x / 4.9) + cos(2 * pi * x / 4.4))
N = 2 ** 12

x = zeros(N, dtype=complexfloating)         # Messpunkte
data = zeros(N, dtype=complexfloating)      # Wahres Signal
pd = zeros(N, dtype=complexfloating)        # Perturbed Signal oder Messung
apd = zeros(N, dtype=complexfloating)       # Gedaempfte Messung
fy = zeros(N, dtype=complexfloating)        # Gefilterte gedaempfte Messung
sld_data = zeros(N, dtype=complexfloating)  # Spektrale Leistungsdichte des wahren Signals
sld_pd = zeros(N, dtype=complexfloating)    # Spektrale Leistungsdichte der Messung
sld_apd = zeros(N, dtype=complexfloating)   # Spektrale Leistungsdichte der gedaempften Messung
sld_fy = zeros(N, dtype=complexfloating)    # Spektrale Leistungsdichte der gefilterten und gedaempften Messung


# ex. NMR.a

###################################################################
#                                                                 #
# TODO: Bauen Sie hier die Punkte 'x' und das wahre Signal 'data' #
#       und berechnen Sie die spektrale Leistungsdichte           #
#                                                                 #
###################################################################

figure(figsize=(14, 10))
plot(sld_data[:N/2], 'b-', label='Signal')
grid(True)
xlim(0, N/2)
xlabel('k')
ylabel(r'$| c_k |^2$')
legend()
title('Spektrale Leistungsdichte des  Signals')
savefig('NMRAnalyse_SpekLeistung.png')
show()


# ex. NMR.b

#########################################
#                                       #
# TODO: Bauen Sie hier die Messung 'pd' #
#                                       #
#########################################

figure(figsize=(14, 10))
plot(pd, 'r-', label='Messung')
plot(data, 'b-', label='Signal')
grid(True)
xlim(0, N/2)
ylabel('nmr')
xlabel('x')
legend()
title('Signal und Messung')
savefig('NMRAnalyse_SignalMessung.png')
show()


# ex. NMR.c

######################################################################
#                                                                    #
# TODO: Berechnen Sie hier die spektrale Leistungsdichte der Messung #
#                                                                    #
######################################################################

figure(figsize=(14, 10))
plot(sld_pd[:N/2], 'r-', label='Messung')
grid(True)
xlim(0, N/2)
xlabel('x')
ylabel(r'$| c_k |^2$')
legend()
title('Spektrale Leistungsdichte der Messung')
savefig('NMRAnalyse_SpekLeistungMessung.png')
show()


# ex. NMR.d

#########################################################
#                                                       #
# TODO: Berechnen Sie hier die gedaempfte Messung       #
#       und die entsprechende spektrale Leistungsdichte #
#                                                       #
#########################################################


figure(figsize=(14, 10))
plot(sld_apd[:N / 2], 'm-', label='Gedaempfte Messung')
grid(True)
xlim(0, N/2)
xlabel('k')
ylabel(r'$| c_k |^2$')
legend()
title('Spektrale Leistungsdichte des gedaempften Signals')
savefig('NMRAnalyse_SpekLeistungDampfSignal.png')
show()


# ex NMR.e

###############################################################
#                                                             #
# TODO: Berechnen Sie hier die gefielterte gedaempfte Messung #
#       und die entsprechende spektrale Leistungsdichte       #
#                                                             #
###############################################################


figure(figsize=(14, 10))
plot(sld_fy[:N / 2], 'g-', label='gefilterte Messung')
grid(True)
xlim(0, N/2)
xlabel('k')
ylabel(r'$| c_k |^2$')
legend()
title(r'Spektrale Leistungsdichte der gefilten Messung')
savefig('NMRAnalyse_SpekLeistungFiltMessung.png')
show()

figure(figsize=(14, 10))
subplot(211)
plot(real(data[:N/2]), 'b-', label='Signal')
plot(real(fy[:N/2]), 'g-', label='gefiltertes Signal')
grid(True)
xlim(0, N/2)
xlabel('x')
ylabel('nmr')
legend()

subplot(212)
plot(real(fy[:N/2]), 'g-', label='gefiltertes Signal')
plot(real(data[:N/2]), 'b-', label='Signal')
grid(True)
xlim(0, N/2)
xlabel('x')
ylabel('nmr')
legend()
savefig('NMRAnalyse_FiltSignal.png')
show()
